﻿var ctx;
document.body.innerHTML += '<datalist id="colors"><option value="#ff0000" style="color:#ff0000">Red</option><option value="#ff8800" style="color:#ff8800">Orange</option><option value="#ffff00" style="color:#ffff00">Yellow</option><option value="#00ff00" style="color:#00ff00">Green</option><option value="#0000ff" style="color:#0000ff">Blue</option><option value="#8800ff" style="color:#8800ff">Purple</option></datalist><datalist id="note"><option value="60">C</option><option value="61">C#</option><option value="62">D</option><option value="63">E♭</option><option value="64">E</option><option value="65">F</option><option value="66">F#</option><option value="67">G</option><option value="68">A♭</option><option value="69">A</option><option value="70">B♭</option><option value="71">B</option><option value="72">C</option></datalist><datalist id="angle"><option value="0">Up</option><option value="90">Right</option><option value="180">Down</option><option value="270">Left</option></datalist>';
function drawWorkspace(id,tid,toolbox){
ctx = document.getElementById(id).getContext("2d");
var w = document.getElementById(id).width;var h = document.getElementById(id).height;
ctx.fillStyle="#eee";ctx.fillRect(0,0,toolbox.width,h);
var categoryBg = Math.ceil(toolbox.categories.length / 2) * 25;
ctx.fillStyle="#ddd";ctx.fillRect(0,0,toolbox.width,categoryBg);
for(var i = 0;i < toolbox.categories.length;i++){var c = toolbox.categories[i];
ctx.fillStyle=c.color;ctx.fillRect((i % 2) * (toolbox.width / 2),(Math.ceil((i + 1) / 2) * 25) - 25,25,25);
ctx.fillStyle="#000000";ctx.font = "20px Arial";ctx.fillText(c.name,(i % 2) * (toolbox.width / 2) + 30,(Math.ceil((i + 1) / 2) * 25) - 5);
for(var n = 0;n < c.blocks.length;n++){drawBlock(c.blocks[n],15,(categoryBg + 10) + (n * 45),document.getElementById(tid));}};}
function drawBlock(b,x,y,t){
ctx.fillStyle=b.color;ctx.beginPath();
if(b.type === "stack"){ctx.moveTo(x,y);ctx.lineTo(x + 10,y);ctx.lineTo(x + 10,y + 10);ctx.lineTo(x + 20,y + 10);ctx.lineTo(x + 20,y);ctx.lineTo(x + getBlockWidth(b),y);ctx.lineTo(x + getBlockWidth(b),y + 30);ctx.lineTo(x + 20,y + 30);ctx.lineTo(x + 20,y + 40);ctx.lineTo(x + 10,y + 40);ctx.lineTo(x + 10,y 
+ 30);ctx.lineTo(x,y + 30);ctx.lineTo(x,y);};
if(b.type === "report"){ctx.moveTo(x,y);ctx.lineTo(x + getBlockWidth(b),y);ctx.lineTo(x + getBlockWidth(b),y + 30);ctx.lineTo(x,y + 30);ctx.lineTo(x,y)};
ctx.fill();ctx.stroke();ctx.closePath();
t.innerHTML += "<div style='position:fixed;top:"+y+"px;left:"+x+"px;width:"+getBlockWidth(b)+"px;height:30px'></div>";
var c = 0;
for(var i = 0;i < b.block.length;i++){
var bl = b.block[i];
if(bl.type === "text"){ctx.fillStyle="#ffffff";ctx.font = "15px Arial";ctx.fillText(bl.value,x + c,y + 20);c += ctx.measureText(bl.value).width};
if(bl.type === "textinput"){t.children[t.childElementCount - 1].innerHTML+="<input type='text' value='"+bl.value+"'  id='kblock-"+b.name+"-"+i+"' style='position:fixed;top:" + (y + 5) + "px;left:"+(c + x)+"px;width:"+(ctx.measureText(bl.value).width + 4)+"px'>";c += ctx.measureText(bl.value).width + 4;};
if(bl.type === "color"){t.children[t.childElementCount - 1].innerHTML+="<input type='text' list='colors' maxlength='7' value='"+bl.value+"'  id='kblock-"+b.name+"-"+i+"' style='position:fixed;top:" + (y + 5) + "px;left:"+(c + x)+"px;width:75px'>";c += 79;};
if(bl.type === "number"){t.children[t.childElementCount - 1].innerHTML+="<input type='number' min='-1000000' max='1000000' step='0.001' value='"+bl.value+"'  id='kblock-"+b.name+"-"+i+"' style='position:fixed;top:" + (y + 5) + "px;left:"+(c + x)+"px;width:75px'>";c += 79;};
if(bl.type === "note"){t.children[t.childElementCount - 1].innerHTML+="<input type='number' list='note' min='0' max='120' step='1' value='"+bl.value+"'  id='kblock-"+b.name+"-"+i+"' style='position:fixed;top:" + (y + 5) + "px;left:"+(c + x)+"px;width:65px'>";c += 69;};
if(bl.type === "angle"){t.children[t.childElementCount - 1].innerHTML+="<input type='number' list='angle' min='0' max='360' step='45' value='"+bl.value+"'  id='kblock-"+b.name+"-"+i+"' style='position:fixed;top:" + (y + 5) + "px;left:"+(c + x)+"px;width:65px'>";c += 69;};
if(bl.type === "select"){t.children[t.childElementCount - 1].innerHTML+="<select value='"+bl.value+"' style='position:fixed;top:" + (y + 5) + "px;left:"+(c + x)+"px;width:"+(ctx.measureText(bl.value).width + 24)+"px' id='kblock-"+b.name+"-"+i+"'></select>";for(var s = 0;s < bl.options.length;s++){document.getElementById("kblock-"+b.name+"-"+i).innerHTML += "<option>"+bl.options[s]+"</option>"};c += ctx.measureText(bl.value).width + 4};c += 2};}
function getBlockWidth(b){var w = 0;for(var i = 0;i < b.block.length;i++){if(b.block[i].type === "color" || b.block[i].type === "number"){w+=75}else if(b.block[i].type === "note" || b.block[i].type === "angle"){w+=65}else{w+=b.block[i].value.length * 8;};if(b.block[i].type !== "text"){w+=6};if(b.block[i].type === "select"){w+=20}};return w}